﻿using StockSharp.Algo;
using StockSharp.Algo.Candles;
using StockSharp.Algo.Strategies;
using StockSharp.Xaml.Charting;

using System;
using System.Linq;
using System.Windows;
using System.Windows.Media;
using System.Windows.Threading;
using Ecng.Xaml;
using Ecng.Collections;
using MoreLinq;
using StockSharp.Algo;
using StockSharp.Algo.Strategies;
using StockSharp.Logging;
using StockSharp.Xaml.Charting;
using StockSharp.Messages;
using Ecng.Common;
using StockSharp.Quik;
using StockSharp.Xaml;

namespace ShowChart
{
    public class MyStrategy: Strategy
    {
        public CandleManager CandleManager { get;  set; }
        public Connector _connector { get;  set; }
        public CandleSeries CandleSeries { get;  set; }
        public bool IsRealtiem { get; set; }
        public ChartArea Area { get; set; }
        public IChart ChartPanel { get; set; }
        public ChartCandleElement ChartCandleElement { get; private set; }

        protected override void OnStarted()
        {
            InitCart();
            CandleManager.WhenCandles(CandleSeries).Do(DisplayNewMarketData).Apply(this);
            ChartPanel.AddElement(Area, ChartCandleElement, CandleSeries);
            base.OnStarted();
        }

        public void InitCart()
        {
            ((ChartPanel)ChartPanel).Elements.ForEach(e => ChartPanel.RemoveElement(Area, e));
            ChartPanel.ClearAreas();

            Area = new ChartArea();
            var yAxis = Area.YAxises.First();
            yAxis.AutoRange = true;
            ChartPanel.IsAutoScroll = true;
            MainWindow.Oder.GuiAsync(()=>
            {
               ((ChartPanel) ChartPanel).ShowOverview = true;
            });
            ChartPanel.AddArea(Area);

            ChartCandleElement = new ChartCandleElement()
            {
                DownFillColor = Brushes.DarkRed.Color,
                UpFillColor = Brushes.DarkGreen.Color,
                DownBorderColor = Brushes.Red.Color,
                UpBorderColor = Brushes.Green.Color,
            };
        }

        private void DisplayNewMarketData(Candle candle)
        {
            IsRealtiem = candle.CloseTime + TimeSpan.FromSeconds(5) > DateTimeOffset.Now || IsRealtiem;

            var chartDrawData = new ChartDrawData();
            var group = chartDrawData.Group(candle.OpenTime);
            group.Add(ChartCandleElement, candle);
            if (IsRealtiem)
                ChartPanel.Draw(chartDrawData);

            if (candle.State != CandleStates.Finished) return;

            ChartPanel.Draw(chartDrawData);
        }

    }
}